Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Problem/TradeRulesProblem.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Problem/TradeRulesProblem.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Problem/TradeRulesProblem.cs	(revision 9262)
@@ -0,0 +1,164 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding; 
+ 
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [Item("TradeRules", "Represents a trade rules in a symbolic regression problem.")]
+    [StorableClass]
+    [Creatable("Problems")]
+    public class TradeRulesProblem : TradeRulesAbstractProblem<IRegressionProblemData, ISymbolicRegressionSingleObjectiveEvaluator, ISymbolicDataAnalysisSolutionCreator>, IRegressionProblem
+    {
+        private const double PunishmentFactor = 10;
+        private const int InitialMaximumTreeDepth = 8;
+        private const int InitialMaximumTreeLength = 25;
+        private const string EstimationLimitsParameterName = "EstimationLimits";
+        private const string EstimationLimitsParameterDescription = "The limits for the estimated value that can be returned by the symbolic regression model.";
+
+        #region parameter properties
+        public IFixedValueParameter<DoubleLimit> EstimationLimitsParameter
+        {
+            get { return (IFixedValueParameter<DoubleLimit>)Parameters[EstimationLimitsParameterName]; }
+        }
+        #endregion
+        #region properties
+        public DoubleLimit EstimationLimits
+        {
+            get { return EstimationLimitsParameter.Value; }
+        }
+        #endregion
+        [StorableConstructor]
+        protected TradeRulesProblem(bool deserializing) : base(deserializing) { }
+        protected TradeRulesProblem(TradeRulesProblem original, Cloner cloner)
+            : base(original, cloner)
+        {
+            RegisterEventHandlers();
+        }
+        public override IDeepCloneable Clone(Cloner cloner) { return new TradeRulesProblem(this, cloner); }
+
+        public TradeRulesProblem()
+            : base(new RegressionProblemData(), new EvaluatorTradeRules(), new SymbolicDataAnalysisExpressionTreeCreator())
+        {
+            Parameters.Add(new FixedValueParameter<DoubleLimit>(EstimationLimitsParameterName, EstimationLimitsParameterDescription));
+
+            EstimationLimitsParameter.Hidden = true;
+
+            Maximization.Value = true;
+            MaximumSymbolicExpressionTreeDepth.Value = InitialMaximumTreeDepth;
+            MaximumSymbolicExpressionTreeLength.Value = InitialMaximumTreeLength;
+
+            RegisterEventHandlers();
+            ConfigureGrammarSymbols();
+            InitializeOperators();
+            UpdateEstimationLimits();
+        }
+
+        [StorableHook(HookType.AfterDeserialization)]
+        private void AfterDeserialization()
+        {
+            RegisterEventHandlers();
+            // compatibility
+            bool changed = false;
+            if (!Operators.OfType<SymbolicRegressionSingleObjectiveTrainingParetoBestSolutionAnalyzer>().Any())
+            {
+                Operators.Add(new SymbolicRegressionSingleObjectiveTrainingParetoBestSolutionAnalyzer());
+                changed = true;
+            }
+            if (!Operators.OfType<SymbolicRegressionSingleObjectiveValidationParetoBestSolutionAnalyzer>().Any())
+            {
+                Operators.Add(new SymbolicRegressionSingleObjectiveValidationParetoBestSolutionAnalyzer());
+                changed = true;
+            }
+            if (changed)
+            {
+                ParameterizeOperators();
+            }
+        }
+
+        private void RegisterEventHandlers()
+        {
+            SymbolicExpressionTreeGrammarParameter.ValueChanged += (o, e) => ConfigureGrammarSymbols();
+        }
+
+        private void ConfigureGrammarSymbols()
+        {
+            var grammar = SymbolicExpressionTreeGrammar as Grammar;
+            if (grammar != null) grammar.ConfigureAsDefaultRegressionGrammar();
+        }
+
+        private void InitializeOperators()
+        {
+            Operators.Add(new TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer());
+            Operators.Add(new TradeRulesSingleObjectiveValidationBestSolutionAnalyzer());
+            Operators.Add(new SymbolicRegressionSingleObjectiveOverfittingAnalyzer());
+            Operators.Add(new SymbolicRegressionSingleObjectiveTrainingParetoBestSolutionAnalyzer());
+            Operators.Add(new SymbolicRegressionSingleObjectiveValidationParetoBestSolutionAnalyzer());
+
+            ParameterizeOperators();
+        }
+
+        private void UpdateEstimationLimits()
+        {
+            if (ProblemData.TrainingIndices.Any())
+            {
+                var targetValues = ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TrainingIndices).ToList();
+                var mean = targetValues.Average();
+                var range = targetValues.Max() - targetValues.Min();
+                EstimationLimits.Upper = mean + PunishmentFactor * range;
+                EstimationLimits.Lower = mean - PunishmentFactor * range;
+            }
+            else
+            {
+                EstimationLimits.Upper = double.MaxValue;
+                EstimationLimits.Lower = double.MinValue;
+            }
+        }
+
+        protected override void OnProblemDataChanged()
+        {
+            base.OnProblemDataChanged();
+            UpdateEstimationLimits();
+        }
+
+        protected override void ParameterizeOperators()
+        {
+            base.ParameterizeOperators();
+            if (Parameters.ContainsKey(EstimationLimitsParameterName))
+            {
+                var operators = Parameters.OfType<IValueParameter>().Select(p => p.Value).OfType<IOperator>().Union(Operators);
+                foreach (var op in operators.OfType<ISymbolicDataAnalysisBoundedOperator>())
+                {
+                    op.EstimationLimitsParameter.ActualName = EstimationLimitsParameter.Name;
+                }
+            }
+        }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/ITradeRulesSolution.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/ITradeRulesSolution.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/ITradeRulesSolution.cs	(revision 9262)
@@ -0,0 +1,25 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    public interface ITradeRulesSolution : IDataAnalysisSolution
+    {
+        new ISymbolicRegressionModel Model { get; }
+        new IRegressionProblemData ProblemData { get; set; }
+
+        IEnumerable<double> EstimatedTestValues { get; }
+        IEnumerable<double> EstimatedTrainingValues { get; }
+        IEnumerable<double> EstimatedValues { get; }
+        IEnumerable<double> GetEstimatedValues(IEnumerable<int> rows);
+        
+        double TestCash { get; }
+        double TrainingCash { get; }      
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/ITradingRulesSolution.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/ITradingRulesSolution.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/ITradingRulesSolution.cs	(revision 9262)
@@ -0,0 +1,13 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    public interface ITradingRulesSolution : ITradeRulesSolution, ISymbolicDataAnalysisSolution {
+    new ISymbolicRegressionModel Model { get; }
+  }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradeRulesSolution.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradeRulesSolution.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradeRulesSolution.cs	(revision 9262)
@@ -0,0 +1,70 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    /// <summary>
+    /// Represents a regression data analysis solution
+    /// </summary>
+    [StorableClass]
+    public abstract class TradeRulesSolution : TradeRulesSolutionBase
+    {
+       protected readonly Dictionary<int, double> evaluationCache;
+
+    [StorableConstructor]
+    protected TradeRulesSolution(bool deserializing)
+      : base(deserializing) {
+      evaluationCache = new Dictionary<int, double>();
+    }
+    protected TradeRulesSolution(TradeRulesSolution original, Cloner cloner)
+      : base(original, cloner) {
+      evaluationCache = new Dictionary<int, double>(original.evaluationCache);
+    }
+    protected TradeRulesSolution(IRegressionModel model, IRegressionProblemData problemData)
+      : base(model, problemData) {
+      evaluationCache = new Dictionary<int, double>(problemData.Dataset.Rows);
+    }
+
+    protected override void RecalculateResults() {
+      CalculateResults();
+    }
+
+    public override IEnumerable<double> EstimatedValues {
+      get { return GetEstimatedValues(Enumerable.Range(0, ProblemData.Dataset.Rows)); }
+    }
+    public override IEnumerable<double> EstimatedTrainingValues {
+      get { return GetEstimatedValues(ProblemData.TrainingIndices); }
+    }
+    public override IEnumerable<double> EstimatedTestValues {
+      get { return GetEstimatedValues(ProblemData.TestIndices); }
+    }
+
+    public override IEnumerable<double> GetEstimatedValues(IEnumerable<int> rows) {
+      var rowsToEvaluate = rows.Except(evaluationCache.Keys);
+      var rowsEnumerator = rowsToEvaluate.GetEnumerator();
+      var valuesEnumerator = Model.GetEstimatedValues(ProblemData.Dataset, rowsToEvaluate).GetEnumerator();
+
+      while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
+        evaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+      }
+
+      return rows.Select(row => evaluationCache[row]);
+    }
+
+    protected override void OnProblemDataChanged() {
+      evaluationCache.Clear();
+      base.OnProblemDataChanged();
+    }
+
+    protected override void OnModelChanged() {
+      evaluationCache.Clear();
+      base.OnModelChanged();
+    }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradeRulesSolutionBase.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradeRulesSolutionBase.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradeRulesSolutionBase.cs	(revision 9262)
@@ -0,0 +1,235 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+      [StorableClass]
+    public abstract class TradeRulesSolutionBase : DataAnalysisSolution, IRegressionSolution
+    {
+        private const string TrainingCashResultName = "Cash after the operation (training)";
+        private const string TestCashResultName = "Cash after the operation (test)";
+        private const string TrainingMeanSquaredErrorResultName = "Mean squared error (training)";
+        private const string TestMeanSquaredErrorResultName = "Mean squared error (test)";
+        private const string TrainingMeanAbsoluteErrorResultName = "Mean absolute error (training)";
+        private const string TestMeanAbsoluteErrorResultName = "Mean absolute error (test)";
+        private const string TrainingSquaredCorrelationResultName = "Pearson's R² (training)";
+        private const string TestSquaredCorrelationResultName = "Pearson's R² (test)";
+        private const string TrainingRelativeErrorResultName = "Average relative error (training)";
+        private const string TestRelativeErrorResultName = "Average relative error (test)";
+        private const string TrainingNormalizedMeanSquaredErrorResultName = "Normalized mean squared error (training)";
+        private const string TestNormalizedMeanSquaredErrorResultName = "Normalized mean squared error (test)";
+        private const string TrainingMeanErrorResultName = "Mean error (training)";
+        private const string TestMeanErrorResultName = "Mean error (test)";
+
+        public new IRegressionModel Model
+        {
+            get { return (IRegressionModel)base.Model; }
+            protected set { base.Model = value; }
+        }
+
+        public new IRegressionProblemData ProblemData
+        {
+            get { return (IRegressionProblemData)base.ProblemData; }
+            set { base.ProblemData = value; }
+        }
+
+        public abstract IEnumerable<double> EstimatedValues { get; }
+        public abstract IEnumerable<double> EstimatedTrainingValues { get; }
+        public abstract IEnumerable<double> EstimatedTestValues { get; }
+        public abstract IEnumerable<double> GetEstimatedValues(IEnumerable<int> rows);
+
+
+        #region Results
+        public double TrainingCash
+        {
+            get { return ((DoubleValue)this[TrainingCashResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingCashResultName].Value).Value = value; }
+        }
+        public double TestCash
+        {
+            get { return ((DoubleValue)this[TestCashResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestCashResultName].Value).Value = value; }
+        }
+        public double TrainingMeanSquaredError
+        {
+            get { return ((DoubleValue)this[TrainingMeanSquaredErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingMeanSquaredErrorResultName].Value).Value = value; }
+        }
+        public double TestMeanSquaredError
+        {
+            get { return ((DoubleValue)this[TestMeanSquaredErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestMeanSquaredErrorResultName].Value).Value = value; }
+        }
+        public double TrainingMeanAbsoluteError
+        {
+            get { return ((DoubleValue)this[TrainingMeanAbsoluteErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingMeanAbsoluteErrorResultName].Value).Value = value; }
+        }
+        public double TestMeanAbsoluteError
+        {
+            get { return ((DoubleValue)this[TestMeanAbsoluteErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestMeanAbsoluteErrorResultName].Value).Value = value; }
+        }
+        public double TrainingRSquared
+        {
+            get { return ((DoubleValue)this[TrainingSquaredCorrelationResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingSquaredCorrelationResultName].Value).Value = value; }
+        }
+        public double TestRSquared
+        {
+            get { return ((DoubleValue)this[TestSquaredCorrelationResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestSquaredCorrelationResultName].Value).Value = value; }
+        }
+        public double TrainingRelativeError
+        {
+            get { return ((DoubleValue)this[TrainingRelativeErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingRelativeErrorResultName].Value).Value = value; }
+        }
+        public double TestRelativeError
+        {
+            get { return ((DoubleValue)this[TestRelativeErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestRelativeErrorResultName].Value).Value = value; }
+        }
+        public double TrainingNormalizedMeanSquaredError
+        {
+            get { return ((DoubleValue)this[TrainingNormalizedMeanSquaredErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingNormalizedMeanSquaredErrorResultName].Value).Value = value; }
+        }
+        public double TestNormalizedMeanSquaredError
+        {
+            get { return ((DoubleValue)this[TestNormalizedMeanSquaredErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestNormalizedMeanSquaredErrorResultName].Value).Value = value; }
+        }
+        public double TrainingMeanError
+        {
+            get { return ((DoubleValue)this[TrainingMeanErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TrainingMeanErrorResultName].Value).Value = value; }
+        }
+        public double TestMeanError
+        {
+            get { return ((DoubleValue)this[TestMeanErrorResultName].Value).Value; }
+            private set { ((DoubleValue)this[TestMeanErrorResultName].Value).Value = value; }
+        }
+        #endregion
+
+
+          [StorableConstructor]
+    protected TradeRulesSolutionBase(bool deserializing) : base(deserializing) { }
+    protected TradeRulesSolutionBase(TradeRulesSolutionBase original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    protected TradeRulesSolutionBase(IRegressionModel model, IRegressionProblemData problemData)
+      : base(model, problemData) {
+          Add(new Result(TrainingCashResultName, "Cash obtained after training period in the stock market", new DoubleValue()));
+      Add(new Result(TestCashResultName, "Cash obtained after test period in the stock market", new DoubleValue()));
+      Add(new Result(TrainingMeanSquaredErrorResultName, "Mean of squared errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestMeanSquaredErrorResultName, "Mean of squared errors of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingSquaredCorrelationResultName, "Squared Pearson's correlation coefficient of the model output and the actual values on the training partition", new DoubleValue()));
+      Add(new Result(TestSquaredCorrelationResultName, "Squared Pearson's correlation coefficient of the model output and the actual values on the test partition", new DoubleValue()));
+      Add(new Result(TrainingRelativeErrorResultName, "Average of the relative errors of the model output and the actual values on the training partition", new PercentValue()));
+      Add(new Result(TestRelativeErrorResultName, "Average of the relative errors of the model output and the actual values on the test partition", new PercentValue()));
+      Add(new Result(TrainingNormalizedMeanSquaredErrorResultName, "Normalized mean of squared errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestNormalizedMeanSquaredErrorResultName, "Normalized mean of squared errors of the model on the test partition", new DoubleValue()));
+      Add(new Result(TrainingMeanErrorResultName, "Mean of errors of the model on the training partition", new DoubleValue()));
+      Add(new Result(TestMeanErrorResultName, "Mean of errors of the model on the test partition", new DoubleValue()));
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization()
+    {
+        // BackwardsCompatibility3.4
+
+        #region Backwards compatible code, remove with 3.5
+
+        if (!ContainsKey(TrainingMeanAbsoluteErrorResultName))
+        {
+            OnlineCalculatorError errorState;
+            Add(new Result(TrainingMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the training partition", new DoubleValue()));
+            double trainingMAE = OnlineMeanAbsoluteErrorCalculator.Calculate(EstimatedTrainingValues, ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TrainingIndices), out errorState);
+            TrainingMeanAbsoluteError = errorState == OnlineCalculatorError.None ? trainingMAE : double.NaN;
+        }
+
+        if (!ContainsKey(TestMeanAbsoluteErrorResultName))
+        {
+            OnlineCalculatorError errorState;
+            Add(new Result(TestMeanAbsoluteErrorResultName, "Mean of absolute errors of the model on the test partition", new DoubleValue()));
+            double testMAE = OnlineMeanAbsoluteErrorCalculator.Calculate(EstimatedTestValues, ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TestIndices), out errorState);
+            TestMeanAbsoluteError = errorState == OnlineCalculatorError.None ? testMAE : double.NaN;
+        }
+
+        if (!ContainsKey(TrainingMeanErrorResultName))
+        {
+            OnlineCalculatorError errorState;
+            Add(new Result(TrainingMeanErrorResultName, "Mean of errors of the model on the training partition", new DoubleValue()));
+            double trainingME = OnlineMeanErrorCalculator.Calculate(EstimatedTrainingValues, ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TrainingIndices), out errorState);
+            TrainingMeanError = errorState == OnlineCalculatorError.None ? trainingME : double.NaN;
+        }
+        if (!ContainsKey(TestMeanErrorResultName))
+        {
+            OnlineCalculatorError errorState;
+            Add(new Result(TestMeanErrorResultName, "Mean of errors of the model on the test partition", new DoubleValue()));
+            double testME = OnlineMeanErrorCalculator.Calculate(EstimatedTestValues, ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TestIndices), out errorState);
+            TestMeanError = errorState == OnlineCalculatorError.None ? testME : double.NaN;
+        }
+        #endregion
+    }
+
+
+    protected void CalculateResults()
+    {
+        IEnumerable<double> estimatedValues = EstimatedValues;
+        IEnumerable<double> estimatedTrainingValues = EstimatedTrainingValues; // cache values
+        IEnumerable<double> originalTrainingValues = ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TrainingIndices);
+        IEnumerable<double> estimatedTestValues = EstimatedTestValues; // cache values
+        IEnumerable<double> originalTestValues = ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TestIndices);
+
+        OnlineCalculatorError errorState;
+        double trainingMSE = OnlineMeanSquaredErrorCalculator.Calculate(originalTrainingValues, estimatedTrainingValues, out errorState);
+        TrainingMeanSquaredError = errorState == OnlineCalculatorError.None ? trainingMSE : double.NaN;
+        double testMSE = OnlineMeanSquaredErrorCalculator.Calculate(originalTestValues, estimatedTestValues, out errorState);
+        TestMeanSquaredError = errorState == OnlineCalculatorError.None ? testMSE : double.NaN;
+
+        double trainingMAE = OnlineMeanAbsoluteErrorCalculator.Calculate(originalTrainingValues, estimatedTrainingValues, out errorState);
+        TrainingMeanAbsoluteError = errorState == OnlineCalculatorError.None ? trainingMAE : double.NaN;
+        double testMAE = OnlineMeanAbsoluteErrorCalculator.Calculate(originalTestValues, estimatedTestValues, out errorState);
+        TestMeanAbsoluteError = errorState == OnlineCalculatorError.None ? testMAE : double.NaN;
+
+        double trainingR2 = OnlinePearsonsRSquaredCalculator.Calculate(originalTrainingValues, estimatedTrainingValues, out errorState);
+        TrainingRSquared = errorState == OnlineCalculatorError.None ? trainingR2 : double.NaN;
+        double testR2 = OnlinePearsonsRSquaredCalculator.Calculate(originalTestValues, estimatedTestValues, out errorState);
+        TestRSquared = errorState == OnlineCalculatorError.None ? testR2 : double.NaN;
+
+        double trainingRelError = OnlineMeanAbsolutePercentageErrorCalculator.Calculate(originalTrainingValues, estimatedTrainingValues, out errorState);
+        TrainingRelativeError = errorState == OnlineCalculatorError.None ? trainingRelError : double.NaN;
+        double testRelError = OnlineMeanAbsolutePercentageErrorCalculator.Calculate(originalTestValues, estimatedTestValues, out errorState);
+        TestRelativeError = errorState == OnlineCalculatorError.None ? testRelError : double.NaN;
+
+        double trainingNMSE = OnlineNormalizedMeanSquaredErrorCalculator.Calculate(originalTrainingValues, estimatedTrainingValues, out errorState);
+        TrainingNormalizedMeanSquaredError = errorState == OnlineCalculatorError.None ? trainingNMSE : double.NaN;
+        double testNMSE = OnlineNormalizedMeanSquaredErrorCalculator.Calculate(originalTestValues, estimatedTestValues, out errorState);
+        TestNormalizedMeanSquaredError = errorState == OnlineCalculatorError.None ? testNMSE : double.NaN;
+
+        double trainingME = OnlineMeanErrorCalculator.Calculate(originalTrainingValues, estimatedTrainingValues, out errorState);
+        TrainingMeanError = errorState == OnlineCalculatorError.None ? trainingME : double.NaN;
+        double testME = OnlineMeanErrorCalculator.Calculate(originalTestValues, estimatedTestValues, out errorState);
+        TestMeanError = errorState == OnlineCalculatorError.None ? testME : double.NaN;
+
+        double trainingCTR = OnlineTradeRulesCalculator.Calculate(estimatedTrainingValues, ProblemData, ProblemData.TrainingIndices);
+        TrainingCash = trainingCTR;
+        double testCTR = OnlineTradeRulesCalculator.Calculate(estimatedTestValues, ProblemData, ProblemData.TestIndices);
+        TestCash = testCTR;
+    }
+
+
+   }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradingRulesSolution.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradingRulesSolution.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Solution/TradingRulesSolution.cs	(revision 9262)
@@ -0,0 +1,62 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Data;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    [Item(Name = "TradingRulesSolution", Description = "Represents a trade rules solution (model + data) and attributes of the solution like cash earned")]
+    public sealed class TradingRulesSolution : TradeRulesSolution, ISymbolicRegressionSolution 
+    {
+    private const string ModelLengthResultName = "Model Length";
+    private const string ModelDepthResultName = "Model Depth";
+
+    public new ISymbolicRegressionModel Model {
+      get { return (ISymbolicRegressionModel)base.Model; }
+      set { base.Model = value; }
+    }
+    ISymbolicDataAnalysisModel ISymbolicDataAnalysisSolution.Model {
+      get { return (ISymbolicDataAnalysisModel)base.Model; }
+    }
+    public int ModelLength {
+      get { return ((IntValue)this[ModelLengthResultName].Value).Value; }
+      private set { ((IntValue)this[ModelLengthResultName].Value).Value = value; }
+    }
+
+    public int ModelDepth {
+      get { return ((IntValue)this[ModelDepthResultName].Value).Value; }
+      private set { ((IntValue)this[ModelDepthResultName].Value).Value = value; }
+    }
+
+    [StorableConstructor]
+    private TradingRulesSolution(bool deserializing) : base(deserializing) { }
+    private TradingRulesSolution(TradingRulesSolution original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public TradingRulesSolution(ISymbolicRegressionModel model, IRegressionProblemData problemData)
+      : base(model, problemData) {
+      Add(new Result(ModelLengthResultName, "Length of the symbolic regression model.", new IntValue()));
+      Add(new Result(ModelDepthResultName, "Depth of the symbolic regression model.", new IntValue()));
+      RecalculateResults();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+        return new TradingRulesSolution(this, cloner);
+    }
+
+    protected override void RecalculateResults() {
+      base.RecalculateResults();
+      ModelLength = Model.SymbolicExpressionTree.Length;
+      ModelDepth = Model.SymbolicExpressionTree.Depth;
+    }
+    }
+}
